<ui:composition xmlns:c="http://java.sun.com/jstl/core"
                xmlns:ui="http://java.sun.com/jsf/facelets" xmlns:h="http://java.sun.com/jsf/html"
                xmlns="http://www.w3.org/1999/xhtml">
    <c:forEach items="#{menu.items}" var="item" varStatus="menuCounter">
        <h:panelGroup rendered="#{item.visible and not empty item.items}">
            <li id="menu-dropdown-#{menuCounter.index}" class="dropdown">
                <a href="#" class="dropdown-toggle" data-toggle="dropdown" role="button"
                   aria-expanded="false">
                    <h:outputText value="#{messages[item.page.label]}"/>
                    <span class="caret"/>
                </a>

                <ul class="dropdown-menu" role="menu">
                    <c:forEach items="#{item.items}" var="child">
                        <h:panelGroup rendered="#{child.visible and not empty child.items}">
                            <li class="dropdown-submenu">
                                <h:outputLink value="#">
                                    <ui:include
                                            src="#{icon_template == null ? '/layout/menu/_image_icon_template.xhtml' : icon_template}">
                                        <ui:param name="icon_path" value="#{child.page.icon}"/>
                                    </ui:include>
                                    <h:outputText value="#{messages[child.page.label]}"/>
                                </h:outputLink>
                                <ul class="dropdown-menu">
                                    <c:forEach items="#{child.items}" var="subChild">
                                        <h:panelGroup
                                                rendered="#{subChild.visible and not empty subChild.items}">
                                            <li class="dropdown-submenu">
                                                <a href="#">
                                                    <ui:include
                                                            src="#{icon_template == null ? '/layout/menu/_image_icon_template.xhtml' : icon_template}">
                                                        <ui:param name="icon_path" value="#{subChild.page.icon}"/>
                                                    </ui:include>
                                                    <h:outputText
                                                            value="#{messages[subChild.page.label]}"/>
                                                </a>
                                                <ul class="dropdown-menu">
                                                    <c:forEach items="#{subChild.items}"
                                                               var="subsubChild">
                                                        <h:panelGroup
                                                                rendered="#{subsubChild.visible}">
                                                            <li>
                                                                <h:outputLink
                                                                        value="/#{url_base_name}#{subsubChild.page.getMenuLink()}">
                                                                    <ui:include
                                                                            src="#{icon_template == null ? '/layout/menu/_image_icon_template.xhtml' : icon_template}">
                                                                        <ui:param name="icon_path"
                                                                                  value="#{subsubChild.page.icon}"/>
                                                                    </ui:include>
                                                                    <h:outputText
                                                                            value="#{messages[subsubChild.page.label]}"/>
                                                                </h:outputLink>
                                                            </li>
                                                        </h:panelGroup>
                                                    </c:forEach>
                                                </ul>
                                            </li>
                                        </h:panelGroup>
                                        <h:panelGroup
                                                rendered="#{subChild.visible}">
                                            <li>
                                                <h:outputLink rendered="#{empty subChild.items}"
                                                              value="/#{url_base_name}#{subChild.page.getMenuLink()}">
                                                    <ui:include
                                                            src="#{icon_template == null ? '/layout/menu/_image_icon_template.xhtml' : icon_template}">
                                                        <ui:param name="icon_path" value="#{subChild.page.icon}"/>
                                                    </ui:include>
                                                    <h:outputText value="#{messages[subChild.page.label]}"/>
                                                </h:outputLink>
                                            </li>
                                        </h:panelGroup>
                                    </c:forEach>
                                </ul>
                            </li>
                        </h:panelGroup>
                        <!-- First element under dropdown menu item -->
                        <h:panelGroup rendered="#{child.visible and empty child.items}">
                            <li>
                                <h:outputLink
                                        value="/#{url_base_name}#{child.page.getMenuLink()}">
                                    <ui:include
                                            src="#{icon_template == null ? '/layout/menu/_image_icon_template.xhtml' : icon_template}">
                                        <ui:param name="icon_path" value="#{child.page.icon}"/>
                                    </ui:include>
                                    <h:outputText value="#{messages[child.page.label]}"/>
                                </h:outputLink>
                            </li>
                        </h:panelGroup>
                    </c:forEach>
                </ul>
            </li>
        </h:panelGroup>
        <h:panelGroup rendered="#{item.visible and empty item.items}" styleClass="nav navbar-nav">
            <li id="menu-#{menuCounter.index}" class="dropdown">
                <h:outputLink
                        value="/#{url_base_name}#{item.page.getMenuLink()}">
                    <ui:include
                            src="#{icon_template == null ? '/layout/menu/_image_icon_template.xhtml' : icon_template}">
                        <ui:param name="icon_path" value="#{item.page.icon}"/>
                    </ui:include>
                    <h:outputText value="#{messages[item.page.label]}"/>
                </h:outputLink>
            </li>
        </h:panelGroup>
    </c:forEach>
</ui:composition>